import os
import sys
forge = sys.modules["forge"]

def setup(module):
	pcre_check = os.popen('pcre-config --version','r')
	pcre_version = pcre_check.read()
	pcre_check.close()
	if pcre_version != "":
#		forge.color_on(0, forge.BLUE)
		pcre_version = float(pcre_version)
		sys.stdout.write(str(pcre_version) + " ")
#		forge.color_off()

	srcList = [	"pcre.pmh",
				"pcreDL" ]

	dll = module.DLL( "fexPcre", srcList )

	deplibs = [ "fePlatformLib" ]

	dll.linkmap = {}
	dll.linkmap["pcre"] = "-lpcrecpp"

	forge.deps( ["fexPcreLib"], deplibs )

def auto(module):
	test_file = """
#include <pcrecpp.h>

int main(void)
{
	return pcrecpp::RE("a?c").FullMatch("abc");
}
    \n"""

	scenemap = { }
	if forge.fe_os == "FE_LINUX":
		scenemap["scenelibs"] = "-lpcrecpp"

	return forge.cctest(test_file, scenemap)
