import sys
forge = sys.modules["forge"]

import os.path

def setup(module):
	srcList = [	"DrawRayTrace",
				"ray.pmh",
				"rayLib" ]

	forge.objlists['ray'] = module.SrcToObj(srcList)

	srcList += [ "rayDL" ]

	dll = module.DLL( "fexRayDL", srcList )

	deplibs = forge.corelibs+ [
				"feSignalLib",
				"fexDataToolDLLib" ]

	forge.deps( ["fexRayDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexRayDL",							None,	None) ]

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer'):
		module.Module( 'test' )
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-viewer ")
		forge.color_off()
