/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#define FE_WKT_DEBUG	FALSE

#include "tbb/tbb.pmh"

using namespace fe;

void WorkTbb::initialize(void)
{
}

void WorkTbb::run(sp<WorkI> a_spWorkI,U32 a_threads,
	sp<SpannedRange> a_spSpannedRange,String a_stage)
{
	m_spWorkI=a_spWorkI;

#if FE_WKT_DEBUG
	feLog("WorkTbb::run %d threads\n",a_threads);
#endif

	Range range(a_spSpannedRange);
	Body body(a_spWorkI,a_stage);
	tbb::parallel_for(range,body);

	m_spWorkI->setThreading(WorkI::e_singleThread);

	//* TODO post-atomic here

	m_spWorkI=NULL;

//	m_spGang->resolveException();

#if FE_WKT_DEBUG
	feLog("WorkTbb::run done\n");
#endif
}

WorkTbb::Range::Range(Range& a_rRange,tbb::split)
{
	//* NOTE (this) is new range; argument is the original range to split

	sp<SpannedRange> spOriginal=a_rRange.spannedRange();
	sp<SpannedRange> spNew0;
	sp<SpannedRange> spNew1;

	spOriginal->split(spNew0,spNew1);

	m_spSpannedRange=spNew0;
	a_rRange.m_spSpannedRange=spNew1;
}
